config/routes.rb
Rails.application.routes.draw do
  root 'temperatures#show'
  namespace :temperatures do
    get :show
    get :edit
    patch :update
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/setting.rb
# RailsSettings Model
class Setting < RailsSettings::Base
  field :cold_tempmerature_upper, type: :integer, default: 20, validates: { presence: true }
  field :warm_tempmerature_upper, type: :integer, default: 30, validates: { presence: true }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/temperatures_controller.rb
class TemperaturesController < ApplicationController
  http_basic_authenticate_with name: Rails.application.config.basic_auth_user,
                               password: Rails.application.config.basic_auth_pass,
                               only: [:edit, :update]

  def show
    @temperature_status = TemperatureManager.status(params[:q]) if params[:q]
  end

  def edit; end

  def update
    if TemperatureManager.update_bounds(params[:cold_tempmerature_upper], params[:warm_tempmerature_upper].to_i)
      redirect_to action: :show
    else
      flash.now[:error] = 'cold > warm'
      render :edit
    end
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/temperatures_helper.rb
module TemperaturesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>ImperoWeather</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <% flash.each do |type, msg| %>
      <div>
        <%= msg %>
      </div>
    <% end %>

    <%= yield %>
  </body>
</html>

app/views/temperatures/edit.html.erb
<%= form_with url: temperatures_update_path, method: :patch do |form| %>
  <%= form.label :cold_tempmerature_upper, "Cold temperature upper limit:" %>
  <%= form.number_field :cold_tempmerature_upper, value: Setting.cold_tempmerature_upper %>

  <%= form.label :warm_tempmerature_upper, "Warm temperature upper limit:" %>
  <%= form.number_field :warm_tempmerature_upper, value: Setting.warm_tempmerature_upper %>

  <%= form.submit "Update" %>
<% end %>

app/views/temperatures/show.html.erb
<h1>Temperature</h1>

<%= form_with url: temperatures_show_path, method: :get do |form| %>
  <%= form.label :q, "Search" %>
  <%= form.text_field :q, value: params[:q] %>

  <%= form.submit "Search" %>
<% end %>


<% if @temperature_status %>
  <p>Curent temperature is <u><%= @temperature_status %></u></p>
<% end %>

<hr>

<%= link_to "Edit Temperature Limits", temperatures_edit_path if Rails.env.development? %>